variables:
  CACHE_COMMON_KEY: $CI_COMMIT_REF_NAME:common


.cache_libs_paths: &cache_libs_paths
  paths:
    - target
    - vendor
    - .cargo

.cache_vendors_libs_paths: &cache_vendors_libs_paths
  paths:
    - vendor
    - .cargo

.cache_services_paths: &cache_services_paths
  paths:
    - target
    - vendor
    - .cargo
    - libs

.cache_vendors_services_paths: &cache_vendors_services_paths
  paths:
    - vendor
    - .cargo
    - libs

.cache_common_services_pull_key: &cache_common_services_pull_key
  - key: $CACHE_COMMON_KEY
    policy: pull
    <<: *cache_services_paths

.cache_common_services_pull_push_key:
  - key: $CACHE_COMMON_KEY
    policy: pull-push
    <<: *cache_services_paths

.cache_vendors_common_services_pull_push_key:
  - key: $CACHE_COMMON_KEY
    policy: pull-push
    <<: *cache_vendors_services_paths

.cache_common_libs_pull_push_key:
  - key: $CACHE_COMMON_KEY
    policy: pull-push
    <<: *cache_libs_paths

.cache_vendors_common_libs_pull_push_key:
  - key: $CACHE_COMMON_KEY
    policy: pull-push
    <<: *cache_vendors_libs_paths


.cache_release:
    cache:
        - *cache_common_services_pull_key

        - key: $CI_COMMIT_REF_NAME:release
          policy: pull-push
          <<: *cache_services_paths


.cache_cargo_audit:
  - key: $CI_COMMIT_REF_NAME:cargo:audit
    policy: pull-push
    paths:
      - .cargo_audit
